Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.jimi.core.util
Class PixelGrabber

    java.lang.Object
      |
      +--com.sun.jimi.core.util.PixelGrabber

public class PixelGrabber
extends java.lang.Object
implements java.awt.image.ImageConsumer

The PixelGrabber class implements an ImageConsumer which can be attached to an Image or ImageProducer object to retrieve a subset of the pixels in that image. Here is an example:

     public void handlesinglepixel(int x, int y, int pixel) {
    	int alpha = (pixel >> 24) & 0xff;
    	int red   = (pixel >> 16) & 0xff;
    	int green = (pixel >>  8) & 0xff;
    	int blue  = (pixel      ) & 0xff;
    	// Deal with the pixel as necessary...
     }

     public void handlepixels(Image img, int x, int y, int w, int h) {
    	int[] pixels = new int[w * h];
    	PixelGrabber pg = new PixelGrabber(img, x, y, w, h, pixels, 0, w);
    	try {
    	    pg.grabPixels();
    	} catch (InterruptedException e) {
    	    System.err.println("interrupted waiting for pixels!");
    	    return;
    	}
    	if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
    	    System.err.println("image fetch aborted or errored");
    	    return;
    	}
    	for (int j = 0; j < h; j++) {
    	    for (int i = 0; i < w; i++) {
    		handlesinglepixel(x+i, y+j, pixels[j * w + i]);
    	    }
    	}
     }

See Also:
  `ColorModel.getRGBdefault()`

Constructor Summary
`PixelGrabber(java.awt.Image img, int x, int y, int w, int h, boolean forceRGB)` Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the specified image.
`PixelGrabber(java.awt.Image img, int x, int y, int w, int h, int[] pix, int off, int scansize)` Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the specified image into the given array.
`PixelGrabber(java.awt.image.ImageProducer ip)` Additional method with usefull signature.
`PixelGrabber(java.awt.image.ImageProducer ip, int x, int y, int w, int h, boolean forceRGB)` Additional method with usefull signature.
`PixelGrabber(java.awt.image.ImageProducer ip, int x, int y, int w, int h, int[] pix, int off, int scansize)` Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the image produced by the specified ImageProducer into the given array.

Method Summary
`void` | `abortGrabbing()` Request the PixelGrabber to abort the image fetch.
`java.awt.image.ColorModel` | `getColorModel()` Get the ColorModel for the pixels stored in the array.
`int` | `getHeight()` Get the height of the pixel buffer (after adjusting for image height).
`java.lang.Object` | `getPixels()` Get the pixel buffer.
`int` | `getStatus()` Return the status of the pixels.
`int` | `getWidth()` Get the width of the pixel buffer (after adjusting for image width).
`boolean` | `grabPixels()` Request the Image or ImageProducer to start delivering pixels and wait for all of the pixels in the rectangle of interest to be delivered.
`boolean` | `grabPixels(long ms)` Request the Image or ImageProducer to start delivering pixels and wait for all of the pixels in the rectangle of interest to be delivered or until the specified timeout has elapsed.
`void` | `imageComplete(int status)` The imageComplete method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setColorModel(java.awt.image.ColorModel model)` The setColorModel method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setDimensions(int width, int height)` The setDimensions method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setHints(int hints)` The setHints method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setPixels(int srcX, int srcY, int srcW, int srcH, java.awt.image.ColorModel model, byte[] pixels, int srcOff, int srcScan)` The setPixels method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setPixels(int srcX, int srcY, int srcW, int srcH, java.awt.image.ColorModel model, int[] pixels, int srcOff, int srcScan)` The setPixels method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `setProperties(java.util.Hashtable props)` The setProperties method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
`void` | `startGrabbing()` Request the PixelGrabber to start fetching the pixels.
`int` | `status()` DEPRECATED: Replaced by getStatus().

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PixelGrabber

    public PixelGrabber(java.awt.Image img,
                        int x,
                        int y,
                        int w,
                        int h,
                        int[] pix,
                        int off,
                        int scansize)

  Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the specified image into the given array. The pixels are stored into the array in the default RGB ColorModel. The RGB data for pixel (i, j) where (i, j) is inside the rectangle (x, y, w, h) is stored in the array at `pix[(j - y) * scansize + (i - x) + off]`.
  Parameters:
    `img` - the image to retrieve pixels from
    `x` - the x coordinate of the upper left corner of the rectangle of pixels to retrieve from the image, relative to the default (unscaled) size of the image
    `y` - the y coordinate of the upper left corner of the rectangle of pixels to retrieve from the image
    `w` - the width of the rectangle of pixels to retrieve
    `h` - the height of the rectangle of pixels to retrieve
    `pix` - the array of integers which are to be used to hold the RGB pixels retrieved from the image
    `off` - the offset into the array of where to store the first pixel
    `scansize` - the distance from one row of pixels to the next in the array
  See Also:
    `ColorModel.getRGBdefault()`

### PixelGrabber

    public PixelGrabber(java.awt.image.ImageProducer ip,
                        int x,
                        int y,
                        int w,
                        int h,
                        int[] pix,
                        int off,
                        int scansize)

  Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the image produced by the specified ImageProducer into the given array. The pixels are stored into the array in the default RGB ColorModel. The RGB data for pixel (i, j) where (i, j) is inside the rectangle (x, y, w, h) is stored in the array at `pix[(j - y) * scansize + (i - x) + off]`.
  Parameters:
    `img` - the image to retrieve pixels from
    `x` - the x coordinate of the upper left corner of the rectangle of pixels to retrieve from the image, relative to the default (unscaled) size of the image
    `y` - the y coordinate of the upper left corner of the rectangle of pixels to retrieve from the image
    `w` - the width of the rectangle of pixels to retrieve
    `h` - the height of the rectangle of pixels to retrieve
    `pix` - the array of integers which are to be used to hold the RGB pixels retrieved from the image
    `off` - the offset into the array of where to store the first pixel
    `scansize` - the distance from one row of pixels to the next in the array
  See Also:
    `ColorModel.getRGBdefault()`

### PixelGrabber

    public PixelGrabber(java.awt.Image img,
                        int x,
                        int y,
                        int w,
                        int h,
                        boolean forceRGB)

  Create a PixelGrabber object to grab the (x, y, w, h) rectangular section of pixels from the specified image. The pixels are accumulated in the original ColorModel if the same ColorModel is used for every call to setPixels, otherwise the pixels are accumulated in the default RGB ColorModel. If the forceRGB parameter is true, then the pixels will be accumulated in the default RGB ColorModel anywya. A buffer is allocated by the PixelGrabber to hold the pixels in either case. If (w < 0) or (h < 0), then they will default to the remaining width and height of the source data when that information is delivered.
  Parameters:
    `img` - the image to retrieve the image data from
    `x` - the x coordinate of the upper left corner of the rectangle of pixels to retrieve from the image, relative to the default (unscaled) size of the image
    `y` - the y coordinate of the upper left corner of the rectangle of pixels to retrieve from the image
    `w` - the width of the rectangle of pixels to retrieve
    `h` - the height of the rectangle of pixels to retrieve
    `forceRGB` - true if the pixels should always be converted to the default RGB ColorModel

### PixelGrabber

    public PixelGrabber(java.awt.image.ImageProducer ip,
                        int x,
                        int y,
                        int w,
                        int h,
                        boolean forceRGB)

  Additional method with usefull signature.

### PixelGrabber

    public PixelGrabber(java.awt.image.ImageProducer ip)

  Additional method with usefull signature. Just defaults the x, y, w, h to 0, 0, -1, -1 to grab all possible data.

Method Detail

### startGrabbing

    public void startGrabbing()

  Request the PixelGrabber to start fetching the pixels.

### abortGrabbing

    public void abortGrabbing()

  Request the PixelGrabber to abort the image fetch.

### grabPixels

    public boolean grabPixels()
                       throws java.lang.InterruptedException

  Request the Image or ImageProducer to start delivering pixels and wait for all of the pixels in the rectangle of interest to be delivered.
  Returns:
    true if the pixels were successfully grabbed, false on abort, error or timeout
  Throws:
    java.lang.InterruptedException - Another thread has interrupted this thread.

### grabPixels

    public boolean grabPixels(long ms)
                       throws java.lang.InterruptedException

  Request the Image or ImageProducer to start delivering pixels and wait for all of the pixels in the rectangle of interest to be delivered or until the specified timeout has elapsed.
  Parameters:
    `ms` - the number of milliseconds to wait for the image pixels to arrive before timing out
  Returns:
    true if the pixels were successfully grabbed, false on abort, error or timeout
  Throws:
    java.lang.InterruptedException - Another thread has interrupted this thread.

### getStatus

    public int getStatus()

  Return the status of the pixels. The ImageObserver flags representing the available pixel information are returned.
  Returns:
    the bitwise OR of all relevant ImageObserver flags
  See Also:
    `ImageObserver`

### getWidth

    public int getWidth()

  Get the width of the pixel buffer (after adjusting for image width). If no width was specified for the rectangle of pixels to grab then then this information will only be available after the image has delivered the dimensions.
  Returns:
    the final width used for the pixel buffer or -1 if the width is not yet known
  See Also:
    `getStatus()`

### getHeight

    public int getHeight()

  Get the height of the pixel buffer (after adjusting for image height). If no width was specified for the rectangle of pixels to grab then then this information will only be available after the image has delivered the dimensions.
  Returns:
    the final height used for the pixel buffer or -1 if the height is not yet known
  See Also:
    `getStatus()`

### getPixels

    public java.lang.Object getPixels()

  Get the pixel buffer. If the PixelGrabber was not constructed with an explicit pixel buffer to hold the pixels then this method will return null until the size and format of the image data is known. Since the PixelGrabber may fall back on accumulating the data in the default RGB ColorModel at any time if the source image uses more than one ColorModel to deliver the data, the array object returned by this method may change over time until the image grab is complete.
  Returns:
    either a byte array or an int array
  See Also:
    `getStatus()`

### getColorModel

    public java.awt.image.ColorModel getColorModel()

  Get the ColorModel for the pixels stored in the array. If the PixelGrabber was constructed with an explicit pixel buffer then this method will always return the default RGB ColorModel, otherwise it may return null until the ColorModel used by the ImageProducer is known. Since the PixelGrabber may fall back on accumulating the data in the default RGB ColorModel at any time if the source image uses more than one ColorModel to deliver the data, the ColorModel object returned by this method may change over time until the image grab is complete.
  Returns:
    the ColorModel object used for storing the pixels
  See Also:
    `getStatus()`, `ColorModel.getRGBdefault()`

### setDimensions

    public void setDimensions(int width,
                              int height)

  The setDimensions method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setDimensions in interface java.awt.image.ImageConsumer

### setHints

    public void setHints(int hints)

  The setHints method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setHints in interface java.awt.image.ImageConsumer

### setProperties

    public void setProperties(java.util.Hashtable props)

  The setProperties method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setProperties in interface java.awt.image.ImageConsumer

### setColorModel

    public void setColorModel(java.awt.image.ColorModel model)

  The setColorModel method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setColorModel in interface java.awt.image.ImageConsumer

### setPixels

    public void setPixels(int srcX,
                          int srcY,
                          int srcW,
                          int srcH,
                          java.awt.image.ColorModel model,
                          byte[] pixels,
                          int srcOff,
                          int srcScan)

  The setPixels method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setPixels in interface java.awt.image.ImageConsumer

### setPixels

    public void setPixels(int srcX,
                          int srcY,
                          int srcW,
                          int srcH,
                          java.awt.image.ColorModel model,
                          int[] pixels,
                          int srcOff,
                          int srcScan)

  The setPixels method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    setPixels in interface java.awt.image.ImageConsumer

### imageComplete

    public void imageComplete(int status)

  The imageComplete method is part of the ImageConsumer API which this class must implement to retrieve the pixels.
  Specified by:
    imageComplete in interface java.awt.image.ImageConsumer

### status

    public int status()

  DEPRECATED: Replaced by getStatus().

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD